package org.openjdk.gcbench.alloc.special;

import org.openjdk.jmh.annotations.*;
import org.openjdk.jmh.infra.Blackhole;

import java.util.concurrent.TimeUnit;

@BenchmarkMode(Mode.AverageTime)
@OutputTimeUnit(TimeUnit.NANOSECONDS)
@State(Scope.Benchmark)
public class Finalizables {

    @Benchmark
    public void test(Blackhole bh) {
        bh.consume(new Finalizable());
        bh.consume(new byte[10000]);
    }

    public static class Finalizable {
        @Override
        protected void finalize() throws Throwable {
            super.finalize();
        }
    }

}
