package org.openjdk.shenandoah.wip;

import org.openjdk.jmh.annotations.*;

import java.util.concurrent.TimeUnit;
import java.util.concurrent.atomic.AtomicReference;

@Warmup(iterations = 5, time = 1, timeUnit = TimeUnit.SECONDS)
@Measurement(iterations = 5, time = 1, timeUnit = TimeUnit.SECONDS)
@Fork(1)
@BenchmarkMode(Mode.AverageTime)
@OutputTimeUnit(TimeUnit.NANOSECONDS)
@Threads(1)
@State(Scope.Benchmark)
public class WeakCasBarriers {

    AtomicReference ai;

    Object t1, t2;

    @Setup
    public void setup() {
        ai = new AtomicReference();
        t1 = new Object();
        t2 = new Object();
    }

    @Benchmark
    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
    public void test() {
        AtomicReference ai = this.ai;
        ai.weakCompareAndSet(t1, t2);
        ai.weakCompareAndSet(t2, t1);
    }

}
